SystemOrganization addCategory: #SeamlessDebugTest!

Object subclass: #ProcessForDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeamlessDebugTest'!

ProcessForDebugger class
	instanceVariableNames: 'process currentResult debugSession'!

!ProcessForDebugger commentStamp: 'DenisKudryashov 11/18/2015 10:59' prior: 0!
On client side run this script to start remote debug session:

processClass := '127.0.0.1:40080' globalAt: #ProcessForDebugger.
processToDebug := processClass run.

debugger := SpecDebugger new.
debugger process: processToDebug controller: nil context: processToDebug suspendedContext.
debugger openFullNoSuspendLabel: 'test remote session'.!

ProcessForDebugger class
	instanceVariableNames: 'process currentResult debugSession'!

!ProcessForDebugger class methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 11/17/2015 16:04'!
body

	| currentNumber |
	currentNumber := 1.
	
	[currentNumber < SmallInteger maxVal ] whileTrue: [ 
	
		self computeFunctionWith: currentNumber.
		3 seconds wait. 
	 ]! !

!ProcessForDebugger class methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 11/18/2015 12:12'!
computeFunctionWith: aNumber

	currentResult := aNumber * 20.
	
	100 seconds wait.
	
	self extraFunction.
	
	self extraFunction2.! !

!ProcessForDebugger class methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 11/17/2015 16:05'!
currentResult
	^currentResult! !

!ProcessForDebugger class methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 11/24/2015 18:06'!
debug

	^debugSession ifNil: [debugSession := DebugSession named: 'remote' on: process startedAt: process suspendedContext].! !

!ProcessForDebugger class methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 11/17/2015 16:51'!
extraFunction

	currentResult := currentResult * 10! !

!ProcessForDebugger class methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 11/18/2015 12:12'!
extraFunction2

	currentResult := currentResult + 1.
	
	! !

!ProcessForDebugger class methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 11/17/2015 16:17'!
process
	^process! !

!ProcessForDebugger class methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 11/18/2015 13:41'!
run

	process ifNotNil: [ process terminate ].
	debugSession := nil.
	
	process := [ self body ] newProcess.

	process resume.
	^process! !
